#ifndef TKQT_QAPPLICATION
#define TKQT_QAPPLICATION

#ifdef TKQT_KDE
#include <kwin.h>
#include <kapplication.h>
#include <klocale.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
//#include <kdestyle.h> //Obsolete in KDE 3.0
#include <kstyle.h>
//#include <kthemestyle.h> //Obsolete in KDE 3.0
#include <kaboutapplication.h>
#endif

#include <qapplication.h>
#include <qwidget.h>
#include <qobject.h>
#include <qobjcoll.h>
#include <qwidcoll.h>
#include <qsize.h>
#include <qstyle.h>
#include <qstylefactory.h>
#include <qstyleplugin.h>
#include <qcdestyle.h>
#include <qcommonstyle.h>
#include <qcompactstyle.h>
#include <qinterlacestyle.h>
#include <qmotifplusstyle.h>
#include <qmotifstyle.h>
#include <qplatinumstyle.h>
#include <qsgistyle.h>
#include <qwindowsstyle.h>
//#include "Themes/metal.h"
//#include "Themes/wood.h"

#include <tcl.h>
#include <tk.h>

#ifdef TKQT_KDE
#define TKQT_APPLICATION   KApplication
#define TKQT_PUSHBUTTON    KPushButton
#define TKQT_Q_OBJECT
#else  /* TKQT_KDE */
#define TKQT_APPLICATION   QApplication
#define TKQT_PUSHBUTTON    QPushButton
#define TKQT_Q_OBJECT      Q_OBJECT
#endif /* TKQT_KDE */

typedef int (*TclCallbackMethod)(void);

/*
 * Use an instance of this class in order to initialise Qt...
 */
class TkQtApplication : public TKQT_APPLICATION
{
    void InitialiseTkQt();
    /*
     * The following pointer will hold a TkQt widget instance that wants to
     * execute a Tcl command, i.e. a TkQbutton that wants to execute its
     * -command argument. Since Qt seems to be multithreaded, its not safe for
     * a TkQt widget to execute directly with Tcl_Eval* the command. What we
     * do here is the following:
     * When we deliver an event to Qt, we check if this pointer is not NULL.
     * In this case, means that a TkQt widget has placed a method here when
     * processing the event. So, we execute this method ...
     */
    TclCallbackMethod  ExecuteWidgetCallback;
    Tcl_Interp        *interp;
    Tcl_Obj           *CommandObj;
    char              *CurrentStyle;
public:
    TkQtApplication(Display *);
    TkQtApplication(Display *, int, char **);
    ~TkQtApplication();
    Tcl_Interp       *MainInterp;
    Tk_Window         MainWindow;

    int ExecuteTclCallabacks() {
      Tcl_Interp *tmp_i;
      Tcl_Obj    *tmp_o;
      int result;
      if (CommandObj == NULL || interp == NULL) return TCL_OK;
      tmp_i  = interp; tmp_o      = CommandObj;
      interp = NULL;   CommandObj = NULL;
      //printf("interp=%p, obj=%p\n", tmp_i, tmp_o);
      //printf("Executing command \"%s\"\n", Tcl_GetString(tmp_o));
      result = Tcl_EvalObjEx(tmp_i, tmp_o, TCL_EVAL_GLOBAL);
      return result;
    }
    void  ArrangeForExecution(Tcl_Interp *Interp, Tcl_Obj *obj) {
      //printf(">> Arranging %s\n", Tcl_GetString(obj));
      interp     = Interp;
      CommandObj = obj;
    };
    void  VisuallyUpdate(void);
    char *StyleDescription(void) {return CurrentStyle;}
    void  StyleDescription(char *description) {CurrentStyle = description;}
};

void EventHandlerWrapper(ClientData clientData, XEvent *eventPtr);
#endif
