#include <TkQButton.h>
#include "moc_TkQButton.cpp"

#define BLACK                            "Black"
#define WHITE                            "White"

#define NORMAL_BG                         "#d9d9d9"
#define ACTIVE_BG                         "#ececec"
#define SELECT_BG                         "#c3c3c3"
#define TROUGH                            "#c3c3c3"
#define INDICATOR                         "#b03060"
#define DISABLED                          "#a3a3a3"
#define DEF_BUTTON_ANCHOR                 "center"
#define DEF_BUTTON_ACTIVE_BG_COLOR        ACTIVE_BG
#define DEF_BUTTON_ACTIVE_BG_MONO         BLACK
#define DEF_BUTTON_ACTIVE_FG_COLOR        BLACK
#define DEF_BUTTON_ACTIVE_FG_MONO         WHITE
#define DEF_BUTTON_BG_COLOR               NORMAL_BG
#define DEF_BUTTON_BG_MONO                WHITE
#define DEF_BUTTON_BITMAP                 ""
#define DEF_BUTTON_BORDER_WIDTH           "2"
#define DEF_BUTTON_CURSOR                 ""
#define DEF_BUTTON_COMPOUND               "none"
#define DEF_BUTTON_COMMAND                ""
#define DEF_BUTTON_DEFAULT                "disabled"
#define DEF_BUTTON_DISABLED_FG_COLOR      DISABLED
#define DEF_BUTTON_DISABLED_FG_MONO       ""
#define DEF_BUTTON_FG                     BLACK
#define DEF_BUTTON_FONT                   "Helvetica -12 bold"
#define DEF_BUTTON_HEIGHT                 "0"
#define DEF_BUTTON_HIGHLIGHT_BG_COLOR     DEF_BUTTON_BG_COLOR
#define DEF_BUTTON_HIGHLIGHT_BG_MONO      DEF_BUTTON_BG_MONO
#define DEF_BUTTON_HIGHLIGHT              BLACK
#define DEF_BUTTON_HIGHLIGHT_WIDTH        "1"
#define DEF_BUTTON_IMAGE                  (char *) NULL
#define DEF_BUTTON_INDICATOR              "1"
#define DEF_BUTTON_JUSTIFY                "center"
#define DEF_BUTTON_OFF_VALUE              "0"
#define DEF_BUTTON_ON_VALUE               "1"
#define DEF_BUTTON_OVER_RELIEF            ""
#define DEF_BUTTON_PADX                   "3m"
#define DEF_BUTTON_PADY                   "1m"
#define DEF_BUTTON_RELIEF                 "raised"
#define DEF_BUTTON_REPEAT_DELAY           "0"
#define DEF_BUTTON_REPEAT_INTERVAL        "0"
#define DEF_BUTTON_SELECT_COLOR           INDICATOR
#define DEF_BUTTON_SELECT_MONO            BLACK
#define DEF_BUTTON_SELECT_IMAGE           (char *) NULL
#define DEF_BUTTON_STATE                  "normal"
#define DEF_BUTTON_TAKE_FOCUS             (char *) NULL
#define DEF_BUTTON_TEXT                   ""
#define DEF_BUTTON_TEXT_VARIABLE          ""
#define DEF_BUTTON_UNDERLINE              "-1"
#define DEF_BUTTON_VALUE                  ""
#define DEF_BUTTON_WIDTH                  "0"
#define DEF_BUTTON_WRAP_LENGTH            "0"

/*
 * Describe our acceptable options...
 */
static Tk_OptionSpec buttonOptionSpecs[] = {
    {TK_OPTION_BORDER, "-activebackground", "activeBackground", "Foreground",
        DEF_BUTTON_ACTIVE_BG_COLOR, -1, Tk_Offset(TkQt_Button, activeBorder),
        0, (ClientData) DEF_BUTTON_ACTIVE_BG_MONO, 0},
    {TK_OPTION_COLOR, "-activeforeground", "activeForeground", "Background",
        DEF_BUTTON_ACTIVE_FG_COLOR, -1, Tk_Offset(TkQt_Button, activeFg),
        TK_OPTION_NULL_OK, (ClientData) DEF_BUTTON_ACTIVE_FG_MONO, 0},
    {TK_OPTION_ANCHOR, "-anchor", "anchor", "Anchor",
        DEF_BUTTON_ANCHOR, -1, Tk_Offset(TkQt_Button, anchor), 0, 0, 0},
    {TK_OPTION_BORDER, "-background", "background", "Background",
        DEF_BUTTON_BG_COLOR, -1, Tk_Offset(TkQt_Button, normalBorder),
        0, (ClientData) DEF_BUTTON_BG_MONO, 0},
    {TK_OPTION_SYNONYM, "-bd", (char *) NULL, (char *) NULL,
        (char *) NULL, 0, -1, 0, (ClientData) "-borderwidth", 0},
    {TK_OPTION_SYNONYM, "-bg", (char *) NULL, (char *) NULL,
        (char *) NULL, 0, -1, 0, (ClientData) "-background", 0},
    {TK_OPTION_BITMAP, "-bitmap", "bitmap", "Bitmap",
        DEF_BUTTON_BITMAP, -1, Tk_Offset(TkQt_Button, bitmap),
        TK_OPTION_NULL_OK, 0, 0},
    {TK_OPTION_PIXELS, "-borderwidth", "borderWidth", "BorderWidth",
        DEF_BUTTON_BORDER_WIDTH, Tk_Offset(TkQt_Button, borderWidthPtr),
        Tk_Offset(TkQt_Button, borderWidth), 0, 0, 0},
    {TK_OPTION_STRING, "-command", "command", "Command",
        DEF_BUTTON_COMMAND, Tk_Offset(TkQt_Button, commandPtr), -1,
        TK_OPTION_NULL_OK, 0, 0},
    {TK_OPTION_STRING_TABLE, "-compound", "compound", "Compound",
         DEF_BUTTON_COMPOUND, -1, Tk_Offset(TkQt_Button, compound), 0,
         (ClientData) compoundStrings, 0},
    {TK_OPTION_CURSOR, "-cursor", "cursor", "Cursor",
        DEF_BUTTON_CURSOR, -1, Tk_Offset(TkQt_Button, cursor),
        TK_OPTION_NULL_OK, 0, 0},
    {TK_OPTION_STRING_TABLE, "-default", "default", "Default",
        DEF_BUTTON_DEFAULT, -1, Tk_Offset(TkQt_Button, defaultState),
        0, (ClientData) defaultStrings, 0},
    {TK_OPTION_COLOR, "-disabledforeground", "disabledForeground",
        "DisabledForeground", DEF_BUTTON_DISABLED_FG_COLOR,
        -1, Tk_Offset(TkQt_Button, disabledFg), TK_OPTION_NULL_OK,
        (ClientData) DEF_BUTTON_DISABLED_FG_MONO, 0},
    {TK_OPTION_SYNONYM, "-fg", "foreground", (char *) NULL,
        (char *) NULL, 0, -1, 0, (ClientData) "-foreground", 0},
    {TK_OPTION_FONT, "-font", "font", "Font",
        DEF_BUTTON_FONT, -1, Tk_Offset(TkQt_Button, tkfont), 0, 0, 0},
    {TK_OPTION_COLOR, "-foreground", "foreground", "Foreground",
        DEF_BUTTON_FG, -1, Tk_Offset(TkQt_Button, normalFg), 0, 0, 0},
    {TK_OPTION_STRING, "-height", "height", "Height",
        DEF_BUTTON_HEIGHT, Tk_Offset(TkQt_Button, heightPtr), -1, 0, 0, 0},
    {TK_OPTION_BORDER, "-highlightbackground", "highlightBackground",
        "HighlightBackground", DEF_BUTTON_HIGHLIGHT_BG_COLOR,
        -1, Tk_Offset(TkQt_Button, highlightBorder), 0,
        (ClientData) DEF_BUTTON_HIGHLIGHT_BG_MONO, 0},
    {TK_OPTION_COLOR, "-highlightcolor", "highlightColor", "HighlightColor",
        DEF_BUTTON_HIGHLIGHT, -1, Tk_Offset(TkQt_Button, highlightColorPtr),
        0, 0, 0},
    {TK_OPTION_PIXELS, "-highlightthickness", "highlightThickness",
        "HighlightThickness", DEF_BUTTON_HIGHLIGHT_WIDTH,
        Tk_Offset(TkQt_Button, highlightWidthPtr),
        Tk_Offset(TkQt_Button, highlightWidth), 0, 0, 0},
    {TK_OPTION_STRING, "-image", "image", "Image",
        DEF_BUTTON_IMAGE, Tk_Offset(TkQt_Button, imagePtr), -1,
        TK_OPTION_NULL_OK, 0, 0},
    {TK_OPTION_JUSTIFY, "-justify", "justify", "Justify",
        DEF_BUTTON_JUSTIFY, -1, Tk_Offset(TkQt_Button, justify), 0, 0, 0},
    {TK_OPTION_RELIEF, "-overrelief", "overRelief", "OverRelief",
         DEF_BUTTON_OVER_RELIEF, -1, Tk_Offset(TkQt_Button, overRelief),
         TK_OPTION_NULL_OK, 0, 0},
    {TK_OPTION_PIXELS, "-padx", "padX", "Pad",
        DEF_BUTTON_PADX, Tk_Offset(TkQt_Button, padXPtr),
        Tk_Offset(TkQt_Button, padX), 0, 0, 0},
    {TK_OPTION_PIXELS, "-pady", "padY", "Pad",
        DEF_BUTTON_PADY, Tk_Offset(TkQt_Button, padYPtr),
        Tk_Offset(TkQt_Button, padY), 0, 0, 0},
    {TK_OPTION_RELIEF, "-relief", "relief", "Relief",
        DEF_BUTTON_RELIEF, -1, Tk_Offset(TkQt_Button, relief),
         0, 0, 0},
    {TK_OPTION_INT, "-repeatdelay", "repeatDelay", "RepeatDelay",
         DEF_BUTTON_REPEAT_DELAY, -1, Tk_Offset(TkQt_Button, repeatDelay),
         0, 0, 0},
    {TK_OPTION_INT, "-repeatinterval", "repeatInterval", "RepeatInterval",
         DEF_BUTTON_REPEAT_INTERVAL, -1, Tk_Offset(TkQt_Button, repeatInterval),
         0, 0, 0},
    {TK_OPTION_STRING_TABLE, "-state", "state", "State",
        DEF_BUTTON_STATE, -1, Tk_Offset(TkQt_Button, state),
        0, (ClientData) stateStrings, 0},
    {TK_OPTION_STRING, "-takefocus", "takeFocus", "TakeFocus",
        DEF_BUTTON_TAKE_FOCUS, Tk_Offset(TkQt_Button, takeFocusPtr), -1,
        TK_OPTION_NULL_OK, 0, 0},
    {TK_OPTION_STRING, "-text", "text", "Text",
        DEF_BUTTON_TEXT, Tk_Offset(TkQt_Button, textPtr), -1, 0, 0, 0},
    {TK_OPTION_STRING, "-textvariable", "textVariable", "Variable",
        DEF_BUTTON_TEXT_VARIABLE, Tk_Offset(TkQt_Button, textVarNamePtr), -1,
        TK_OPTION_NULL_OK, 0, 0},
    {TK_OPTION_INT, "-underline", "underline", "Underline",
        DEF_BUTTON_UNDERLINE, -1, Tk_Offset(TkQt_Button, underline), 0, 0, 0},
    {TK_OPTION_STRING, "-width", "width", "Width",
        DEF_BUTTON_WIDTH, Tk_Offset(TkQt_Button, widthPtr), -1, 0, 0, 0},
    {TK_OPTION_PIXELS, "-wraplength", "wrapLength", "WrapLength",
        DEF_BUTTON_WRAP_LENGTH, Tk_Offset(TkQt_Button, wrapLengthPtr),
        Tk_Offset(TkQt_Button, wrapLength), 0, 0, 0},
    {TK_OPTION_END, (char *) NULL, (char *) NULL, (char *) NULL,
        (char *) NULL, 0, -1, 0, 0, 0}
};

extern TkQtApplication *TkQtApplicationInstance;
static int ConfigureButton(Tcl_Interp *interp, TkQButton *butPtr,
                           int objc, Tcl_Obj *CONST objv[]);
static char *                ButtonTextVarProc _ANSI_ARGS_((ClientData clientData,
                            Tcl_Interp *interp, char *name1, char *name2,
                            int flags));
static void                ButtonImageProc _ANSI_ARGS_((ClientData clientData,
                            int x, int y, int width, int height,
                            int imgWidth, int imgHeight));
static void             ButtonEventProc(ClientData clientData,XEvent *eventPtr);

TkQButton::TkQButton(ClientData clientData, Tcl_Interp *Interp,
                     int objc, Tcl_Obj *CONST objv[]) :
                     TKQT_PUSHBUTTON(0, "TkQButton")
{
  nowDeleting = (char) 0;
  optionTable = (Tk_OptionTable) clientData;
  interp = Interp;
  /*
   * Create the corresponding Tk window.
   */
  tkwin = Tk_CreateWindowFromPath(interp, Tk_MainWindow(interp),
          Tcl_GetString(objv[1]), (char *) NULL);
  if (tkwin == NULL) {
    nowDeleting = (char) 1;
    return;
  }
  //printf("Creating widget %s (%p)\n", Tcl_GetString(objv[1]), this);
  display = Tk_Display(tkwin);
  Tk_MakeWindowExist(tkwin);
  XFlush(display);
  /*
   * Make this Tk window the Qt widget window...
   */
  create(Tk_WindowId(tkwin), TRUE, TRUE);
  /*
   * Arrange XEvents to be delivered to Qt for this window, after have been
   * processed by Tk. This will enable also Tk bindings to work with the Qt
   * widget...
   */
  Tk_CreateEventHandler(tkwin, ~0L, EventHandlerWrapper, NULL);
  Tk_SetClass(tkwin, "TkQButton");
  /*
   * Finally, register our widget to Tcl level...
   */ 
  widgetCmd = Tcl_CreateObjCommand(interp, Tk_PathName(tkwin),
        ButtonWidgetObjCmd, (ClientData) this, ButtonCmdDeletedProc);
  /*
   * Set Default values...
   */
  options.textPtr = NULL;
  options.underline = -1;
  options.textVarNamePtr = NULL;
  options.bitmap = None;
  options.imagePtr = NULL;
  options.image = NULL;
  options.compound = COMPOUND_NONE;
  options.state = STATE_NORMAL;
  options.normalBorder = NULL;
  options.activeBorder = NULL;
  options.borderWidthPtr = NULL;
  options.borderWidth = 0;
  options.relief = TK_RELIEF_FLAT;
  options.highlightWidthPtr = NULL;
  options.highlightWidth = 0;
  options.highlightBorder = NULL;
  options.highlightColorPtr = NULL;
  options.inset = 0;
  options.tkfont = NULL;
  options.normalFg = NULL;
  options.activeFg = NULL;
  options.disabledFg = NULL;
  options.widthPtr = NULL;
  options.width = 0;
  options.heightPtr = NULL;
  options.height = 0;
  options.wrapLengthPtr = NULL;
  options.wrapLength = 0;
  options.padXPtr = NULL;
  options.padX = 0;
  options.padYPtr = NULL;
  options.padY = 0;
  options.anchor = TK_ANCHOR_CENTER;
  options.justify = TK_JUSTIFY_CENTER;
  options.selectBorder = NULL;
  options.textWidth = 0;
  options.textHeight = 0;
  options.textLayout = NULL;
  options.defaultState = DEFAULT_DISABLED;
  options.cursor = None;
  options.takeFocusPtr = NULL;
  options.commandPtr = NULL;

  Tk_CreateEventHandler(tkwin, StructureNotifyMask,
                        ButtonEventProc, (ClientData) this);
                        
  if (Tk_InitOptions(interp, (char *) &options, optionTable, tkwin) != TCL_OK) {
    //printf("Destroying window \"%s\" (%p)\n", Tk_PathName(tkwin), this);
    Tk_DestroyWindow(tkwin);
    nowDeleting = (char) 1;
    return;
  }
  if (ConfigureButton(interp, this, objc - 2, objv + 2) != TCL_OK) {
    //printf("Destroying window \"%s\" (%p)\n", Tk_PathName(tkwin), this);
    Tk_DestroyWindow(tkwin);
    nowDeleting = (char) 1;
    return;
  }

  /*
   * Insert values of supported options to the Qt widget...
   */
  UpdateImage();
/*  XFlush(display);
  if (!strlen(Tcl_GetString(options.textPtr))) {
    UpdateImage();
    XFlush(display);
  } else {
    ComputeButtonGeometry();
  }*/

  connect(this, SIGNAL(clicked()),  SLOT(InvokeTclCommand()));
  connect(this, SIGNAL(pressed()),  SLOT(VisuallyUpdate()));
  connect(this, SIGNAL(released()), SLOT(VisuallyUpdate()));
}

TkQButton::~TkQButton() 
{
  /*
   * Free up all the stuff that requires special handling, then
   * let Tk_FreeOptions handle all the standard option-related
   * stuff.
   */

  if (options.textVarNamePtr != NULL) {
    if (interp) {
      Tcl_UntraceVar(interp, (char *) Tcl_GetString(options.textVarNamePtr),
                     TCL_GLOBAL_ONLY|TCL_TRACE_WRITES|TCL_TRACE_UNSETS,
                     (Tcl_VarTraceProc *) ButtonTextVarProc, (ClientData) this);
    }
    Tcl_DecrRefCount(options.textVarNamePtr);
    options.textVarNamePtr = NULL;
  }
  if (options.image != NULL) {
    Tk_FreeImage(options.image);
    options.image = NULL;
  }
  if (options.textLayout != NULL) {
    Tk_FreeTextLayout(options.textLayout);
    options.textLayout = NULL;
  }
  Tk_FreeConfigOptions((char *) &options, optionTable, tkwin);
  //printf("Destoyed button (%p)!\n", this);
}


void TkQButton::ComputeButtonGeometry(void) {
  QSize pref_size;
  int width, height;
  
  options.inset = options.highlightWidth + options.borderWidth;
  /*
   * Leave room for the default ring if needed.
   */
  if (options.defaultState != DEFAULT_DISABLED) {
    //options.inset += 5;
    setDefault(TRUE);
  } else {
    setDefault(FALSE);
  }

  if (options.borderWidth < 1 || options.relief == TK_RELIEF_FLAT) {
    setFlat(TRUE);
  } else {
    setFlat(FALSE);
  }
  /*
   * Get preferred size from Qt...
   */
  pref_size = sizeHint();
  width  = pref_size.width();
  height = pref_size.height();
  if (options.width  > 0) width  = options.width;
  if (options.height > 0) height = options.height;
  Tk_GeometryRequest(tkwin, width+2*options.inset, height+2*options.inset);
  Tk_SetInternalBorder(tkwin, options.inset);
  //printf("win=%s, cw=%d, ch=%d, pw=%d, ph=%d\n", Tk_PathName(tkwin),
  //  options.width, options.height, pref_size.width(), pref_size.height());
}

void TkQButton::UpdateImage(void) {
  /*
   * This function is responsible for displaying either the label, an image or
   * both...
   */
  if (options.compound == COMPOUND_NONE) {
    /* Either a text or image. Note that image has precedance, if defined... */
    if (options.imagePtr != NULL) {
      /*
       * We rely on the Img extension to get XPM data from the image :-)
       */
      Tcl_Obj *objv[4];
      int i, res, objc = 4;
      objv[0] = Tcl_NewStringObj(Tcl_GetString(options.imagePtr), -1);
      objv[1] = Tcl_NewStringObj("data", -1);
      objv[2] = Tcl_NewStringObj("-format", -1);
      objv[3] = Tcl_NewStringObj("xpm", -1);
      for (i=0; i<objc; i++) {
        Tcl_IncrRefCount(objv[i]);
      }
      res = Tcl_EvalObjv(interp, objc, objv, TCL_EVAL_GLOBAL);
      for (i=0; i<objc; i++) {
        Tcl_DecrRefCount(objv[i]);
      }
      if (res != TCL_OK) {
        printf("Error: %s\n", Tcl_GetString(Tcl_GetObjResult(interp)));
        return;
      }
      char *imageData = Tcl_GetString(Tcl_GetObjResult(interp));
      QByteArray ByteArray;
      ByteArray.setRawData(imageData, strlen(imageData));
      QPixmap Image(ByteArray);
      ByteArray.resetRawData(imageData, strlen(imageData));
      setText(NULL);
      setPixmap(Image);
    } else {
      if (options.textPtr != NULL) {
	setPixmap(NULL);
        setText(QString::fromUtf8(Tcl_GetString(options.textPtr)));
      }
    }
    ComputeButtonGeometry();
    return;
  }
  
  setText(QString::fromUtf8(Tcl_GetString(options.textPtr)));
  if (options.imagePtr != NULL) {
    /*
     * We rely on the Img extension to get XPM data from the image :-)
     */
    Tcl_Obj *objv[4];
    int i, res, objc = 4;
    objv[0] = Tcl_NewStringObj(Tcl_GetString(options.imagePtr), -1);
    objv[1] = Tcl_NewStringObj("data", -1);
    objv[2] = Tcl_NewStringObj("-format", -1);
    objv[3] = Tcl_NewStringObj("xpm", -1);
    for (i=0; i<objc; i++) {
      Tcl_IncrRefCount(objv[i]);
    }
    res = Tcl_EvalObjv(interp, objc, objv, TCL_EVAL_GLOBAL);
    for (i=0; i<objc; i++) {
      Tcl_DecrRefCount(objv[i]);
    }
    if (res != TCL_OK) {
      printf("Error: %s\n", Tcl_GetString(Tcl_GetObjResult(interp)));
      return;
    }
    char *imageData = Tcl_GetString(Tcl_GetObjResult(interp));
    QByteArray ByteArray;
    ByteArray.setRawData(imageData, strlen(imageData));
    QPixmap Image(ByteArray);
    ByteArray.resetRawData(imageData, strlen(imageData));
    QIconSet ISet(Image, QIconSet::Small);
    setIconSet(ISet);
  }
  ComputeButtonGeometry();
}

void TkQButton::resizeEvent(QResizeEvent *e)
{
  //printf("TkQButton: got resize (%d) (%dx%d)\n", winId(), width(), height());
  show();
  VisuallyUpdate();
}

void TkQButton::VisuallyUpdate(void)
{
  XEvent event;
  /*
   * Generate an expose event...
   */
  memset((void *) &event, 0, sizeof(event));
  event.xany.type = Expose;
  event.xany.window = Tk_WindowId(tkwin);
  event.xany.display = Tk_Display(tkwin);
  event.xexpose.type = Expose;
  event.xexpose.display = event.xany.display;
  event.xexpose.window = event.xany.window;
  Tk_QueueWindowEvent(&event, TCL_QUEUE_TAIL);
}

int TkQButton::InvokeTclCommand() {
  TkQtApplicationInstance->ArrangeForExecution(interp, options.commandPtr);
  return TCL_OK;
}

int TkQt_button(ClientData clientData, Tcl_Interp *interp,
                int objc, Tcl_Obj *objv[])
{
  TkQButton *button;
  Tk_OptionTable optionTable;

  optionTable = (Tk_OptionTable) clientData;
  if (optionTable == NULL) {
    Tcl_CmdInfo info;
    char *name;
    /*
     * We haven't created the option table for this widget class
     * yet.  Do it now and save the table as the clientData for
     * the command, so we'll have access to it in future
     * invocations of the command.
     */
    optionTable = Tk_CreateOptionTable(interp, buttonOptionSpecs);
    name = Tcl_GetString(objv[0]);
    Tcl_GetCommandInfo(interp, name, &info);
    info.objClientData = (ClientData) optionTable;
    Tcl_SetCommandInfo(interp, name, &info);
    clientData = (ClientData) optionTable;
  }
  button = new TkQButton(clientData, interp, objc, objv);
  if (button->nowDeleting) {
    //delete button;
    return TCL_ERROR;
  }
  Tcl_SetObjResult(interp, Tcl_NewStringObj(Tk_PathName(button->tkwin), -1));
  return TCL_OK;
}

int 
TkQButton::ButtonWidgetObjCmd(ClientData clientData, Tcl_Interp *interp,
                              int objc, Tcl_Obj *CONST objv[])
{
  TkQButton *button = (TkQButton *) clientData;
  int result, index;
  Tcl_Obj *objPtr = NULL;
  static CONST char *Methods[] = {
    "cget", "configure", "flash", "invoke", (char *) NULL
  };
  enum methods {
    COMMAND_CGET, COMMAND_CONFIGURE, COMMAND_FLASH, COMMAND_INVOKE
  };

  if (objc < 2) {
    Tcl_WrongNumArgs(interp, 1, objv, "option ?arg arg ...?");
    return TCL_ERROR;
  }
  result = Tcl_GetIndexFromObj(interp, objv[1], Methods, "method", 0, &index);
  if (result != TCL_OK) {
    return result;
  }
  /* Handle Arguments... */
  switch ((enum methods) index) {
    case COMMAND_CGET: {
      if (objc != 3) {
        Tcl_WrongNumArgs(interp, 1, objv, "cget option");
        return TCL_ERROR;
      }
      objPtr = Tk_GetOptionValue(interp, (char *) &button->options,
                    button->optionTable, objv[2], button->tkwin);
      if (objPtr == NULL) {
        return TCL_ERROR;
      } else {
        Tcl_SetObjResult(interp, objPtr);
      }
      break;
    }
    case COMMAND_CONFIGURE: {
      if (objc <= 3) {
        objPtr = Tk_GetOptionInfo(interp, (char *) &button->options,
                 button->optionTable, (objc == 3) ? objv[2] : (Tcl_Obj *) NULL,
                 button->tkwin);
        if (objPtr == NULL) {
          return TCL_ERROR;
        } else {
          Tcl_SetObjResult(interp, objPtr);
        }
      } else {
        result = ConfigureButton(interp, button, objc-2, objv+2);
      }
      break;
    }
    case COMMAND_FLASH: {
      if (objc > 2) {
        Tcl_WrongNumArgs(interp, 1, objv, "flash");
        return TCL_ERROR;
      }
      break;
    }
    case COMMAND_INVOKE: {
      if (objc > 2) {
        Tcl_WrongNumArgs(interp, 1, objv, "invoke");
        return TCL_ERROR;
      }
      break;
    }
  }
  return TCL_OK;
}

void
TkQButton::ButtonCmdDeletedProc(ClientData clientData)
{
  TkQButton *button = (TkQButton *) clientData;
  /*
   * If window is not already deleted, delete it...
   */
  if (!button->nowDeleting) {
    //printf("ButtonCmdDeletedProc: destroying window \"%s\" (%p)\n",
    //        Tk_PathName(button->tkwin), button);
    button->nowDeleting = (char) 1;
    Tk_DestroyWindow(button->tkwin);
  }
}

/*
 *----------------------------------------------------------------------
 *
 * ConfigureButton --
 *
 *        This procedure is called to process an objc/objv list to set
 *        configuration options for a button widget.
 *
 * Results:
 *        The return value is a standard Tcl result.  If TCL_ERROR is
 *        returned, then an error message is left in interp's result.
 *
 * Side effects:
 *        Configuration information, such as text string, colors, font,
 *        etc. get set for butPtr;  old resources get freed, if there
 *        were any.  The button is redisplayed.
 *
 *----------------------------------------------------------------------
 */

static int
ConfigureButton(Tcl_Interp *interp, TkQButton *butPtr,
                int objc, Tcl_Obj *CONST objv[])
{
    Tk_SavedOptions savedOptions;
    Tcl_Obj *errorResult = NULL;
    int error, haveImage;
    Tk_Image image;

    /*
     * Eliminate any existing trace on variables monitored by the button.
     */

    if (butPtr->options.textVarNamePtr != NULL) {
      Tcl_UntraceVar(interp,
           (char *) Tcl_GetString(butPtr->options.textVarNamePtr), 
           TCL_GLOBAL_ONLY|TCL_TRACE_WRITES|TCL_TRACE_UNSETS,
           (Tcl_VarTraceProc *) ButtonTextVarProc, (ClientData) butPtr);
    }

    /*
     * The following loop is potentially executed twice.  During the
     * first pass configuration options get set to their new values.
     * If there is an error in this pass, we execute a second pass
     * to restore all the options to their previous values.
     */

    for (error = 0; error <= 1; error++) {
      if (!error) {
        /*
         * First pass: set options to new values.
         */

        if (Tk_SetOptions(interp, (char *) &butPtr->options,
               butPtr->optionTable, objc, (Tcl_Obj *CONST*) objv,
               butPtr->tkwin, &savedOptions, (int *) NULL) != TCL_OK) {
          continue;
        }
      } else {
        /*
         * Second pass: restore options to old values.
         */

        errorResult = Tcl_GetObjResult(interp);
        Tcl_IncrRefCount(errorResult);
        Tk_RestoreSavedOptions(&savedOptions);
      }

      /*
       * A few options need special processing, such as setting the
       * background from a 3-D border, or filling in complicated
       * defaults that couldn't be specified to Tk_SetOptions.
       */

      if ((butPtr->options.state == STATE_ACTIVE)
                && !Tk_StrictMotif(butPtr->tkwin)) {
        Tk_SetBackgroundFromBorder(butPtr->tkwin, butPtr->options.activeBorder);
      } else {
        Tk_SetBackgroundFromBorder(butPtr->tkwin, butPtr->options.normalBorder);
      }
      if (butPtr->options.borderWidth < 0) {
        butPtr->options.borderWidth = 0;
      }
      if (butPtr->options.highlightWidth < 0) {
        butPtr->options.highlightWidth = 0;
      }
      if (butPtr->options.padX < 0) {
        butPtr->options.padX = 0;
      }
      if (butPtr->options.padY < 0) {
        butPtr->options.padY = 0;
      }

      /*
       * Get the images for the widget, if there are any.  Allocate the
       * new images before freeing the old ones, so that the reference
       * counts don't go to zero and cause image data to be discarded.
       */
  
      if (butPtr->options.imagePtr != NULL) {
        image = Tk_GetImage(butPtr->interp, butPtr->tkwin,
                Tcl_GetString(butPtr->options.imagePtr), ButtonImageProc,
                (ClientData) butPtr);
        if (image == NULL) {
          continue;
        }
      } else {
        image = NULL;
      }
      if (butPtr->options.image != NULL) {
        Tk_FreeImage(butPtr->options.image);
      }
      butPtr->options.image = image;

      haveImage = 0;
      if (butPtr->options.imagePtr != NULL || butPtr->options.bitmap != None) {
        haveImage = 1;
      }
      if ((!haveImage || butPtr->options.compound != COMPOUND_NONE)
              && (butPtr->options.textVarNamePtr != NULL)) {
        /*
         * The button must display the value of a variable: set up a trace
         * on the variable's value, create the variable if it doesn't
         * exist, and fetch its current value.
         */
  
        Tcl_Obj *valuePtr, *namePtr;

        namePtr = butPtr->options.textVarNamePtr;
        valuePtr = Tcl_ObjGetVar2(interp, namePtr, NULL, TCL_GLOBAL_ONLY);
        if (valuePtr == NULL) {
          if (Tcl_ObjSetVar2(interp, namePtr, NULL, butPtr->options.textPtr,
                  TCL_GLOBAL_ONLY|TCL_LEAVE_ERR_MSG) == NULL) {
            continue;
          }
        } else {
          if (butPtr->options.textPtr != NULL) {
            Tcl_DecrRefCount(butPtr->options.textPtr);
          }
          butPtr->options.textPtr = valuePtr;
          Tcl_IncrRefCount(butPtr->options.textPtr);
        }
      }
  
      if ((butPtr->options.bitmap != None) ||
          (butPtr->options.imagePtr != NULL)) {
        /*
         * The button must display the contents of an image or
         * bitmap.
         */

        if (Tk_GetPixelsFromObj(interp, butPtr->tkwin, butPtr->options.widthPtr,
                &butPtr->options.width) != TCL_OK) {
          widthError:
          Tcl_AddErrorInfo(interp, "\n    (processing -width option)");
          continue;
        }
        if (Tk_GetPixelsFromObj(interp, butPtr->tkwin,butPtr->options.heightPtr,
                &butPtr->options.height) != TCL_OK) {
          heightError:
          Tcl_AddErrorInfo(interp, "\n    (processing -height option)");
          continue;
        }
      } else {
        /*
         * The button displays an ordinary text string.
         */

        if (Tcl_GetIntFromObj(interp, butPtr->options.widthPtr,
                              &butPtr->options.width) != TCL_OK) {
          goto widthError;
        }
        if (Tcl_GetIntFromObj(interp, butPtr->options.heightPtr,
                              &butPtr->options.height) != TCL_OK) {
          goto heightError;
        }
      }
      break;
  }
  if (!error) {
      Tk_FreeSavedOptions(&savedOptions);
  }

  /*
   * Reestablish the variable traces, if they're needed.
   */

  if (butPtr->options.textVarNamePtr != NULL) {
      Tcl_TraceVar(interp,
              (char *) Tcl_GetString(butPtr->options.textVarNamePtr),
              TCL_GLOBAL_ONLY|TCL_TRACE_WRITES|TCL_TRACE_UNSETS,
              (Tcl_VarTraceProc *) ButtonTextVarProc, (ClientData) butPtr);
  }
  
  // TkButtonWorldChanged((ClientData) butPtr);
  butPtr->ComputeButtonGeometry();
  butPtr->VisuallyUpdate();
  if (error) {
      Tcl_SetObjResult(interp, errorResult);
      Tcl_DecrRefCount(errorResult);
      return TCL_ERROR;
  } else {
      return TCL_OK;
  }
}

/*
 *--------------------------------------------------------------
 *
 * ButtonTextVarProc --
 *
 *        This procedure is invoked when someone changes the variable
 *        whose contents are to be displayed in a button.
 *
 * Results:
 *        NULL is always returned.
 *
 * Side effects:
 *        The text displayed in the button will change to match the
 *        variable.
 *
 *--------------------------------------------------------------
 */

        /* ARGSUSED */
static char *
ButtonTextVarProc(ClientData clientData, Tcl_Interp *interp,
                  char *name1, char *name2, int flags)
{
    TkQButton *butPtr = (TkQButton *) clientData;
    char *name;
    Tcl_Obj *valuePtr;

    name = Tcl_GetString(butPtr->options.textVarNamePtr);

    /*
     * If the variable is unset, then immediately recreate it unless
     * the whole interpreter is going away.
     */

    if (flags & TCL_TRACE_UNSETS) {
        if ((flags & TCL_TRACE_DESTROYED) && !(flags & TCL_INTERP_DESTROYED)) {
            Tcl_SetVar2Ex(interp, name, NULL, butPtr->options.textPtr, 
                    TCL_GLOBAL_ONLY);
            Tcl_TraceVar(interp, (char *) name,
                    TCL_GLOBAL_ONLY|TCL_TRACE_WRITES|TCL_TRACE_UNSETS,
                    (Tcl_VarTraceProc *) ButtonTextVarProc, clientData);
        }
        return (char *) NULL;
    }

    valuePtr = Tcl_GetVar2Ex(interp, name, NULL, TCL_GLOBAL_ONLY);
    if (valuePtr == NULL) {
        valuePtr = Tcl_NewObj();
    }
    Tcl_DecrRefCount(butPtr->options.textPtr);
    butPtr->options.textPtr = valuePtr;
    Tcl_IncrRefCount(butPtr->options.textPtr);
    butPtr->UpdateImage();
    butPtr->ComputeButtonGeometry();
    butPtr->VisuallyUpdate();
    return (char *) NULL;
}

/*
 *----------------------------------------------------------------------
 *
 * ButtonImageProc --
 *
 *        This procedure is invoked by the image code whenever the manager
 *        for an image does something that affects the size or contents
 *        of an image displayed in a button.
 *
 * Results:
 *        None.
 *
 * Side effects:
 *        Arranges for the button to get redisplayed.
 *
 *----------------------------------------------------------------------
 */

static void
ButtonImageProc(ClientData clientData, int x, int y, int width, int height,
                int imgWidth, int imgHeight)
{
  register TkQButton *butPtr = (TkQButton *) clientData;

  if (butPtr->tkwin != NULL) {
    butPtr->UpdateImage();
  }
}

/*
 *--------------------------------------------------------------
 *
 * ButtonEventProc --
 *
 *        This procedure is invoked by the Tk dispatcher for various
 *        events on buttons.
 *
 * Results:
 *        None.
 *
 * Side effects:
 *        When the window gets deleted, internal structures get
 *        cleaned up.  When it gets exposed, it is redisplayed.
 *
 *--------------------------------------------------------------
 */
static void ButtonEventProc(ClientData clientData, XEvent *eventPtr) {
  if (eventPtr->type == DestroyNotify) {
    TkQButton *button = (TkQButton *) clientData;
    //printf("ButtonEventProc: <Destroy> received:\n");
    if (!button->nowDeleting) {
      /*printf("Deleting command %s\n", 
              Tcl_GetCommandName(button->interp, button->widgetCmd));*/
      Tcl_DeleteCommandFromToken(button->interp, button->widgetCmd);
      button->interp = NULL;
    }
    delete (TkQButton *) clientData;
  } else {
    EventHandlerWrapper(clientData, eventPtr);
  }
} /* ButtonEventProc */
